import {pub, sub} from './pubsub.js';
import state from './state.js';
import redraw from './redraw.js';

// "raw" event listeners, which publish meaningful events, which are listened-to further-down:
// ...

  
// "meaningful" event listeners:
//sub('set-current-node', (node_vm)=>{
//  state.current_node_vm = node_vm;
//  redraw();
//  });

// connect to NATS thru WebSockets:
import { connect, StringCodec } from "nats.ws";
const strcodec = StringCodec();
const init_nats = async function(){
  const nc = await connect({servers: "ws://localhost:4223"});
  console.log(nc);
  
  (async ()=>{
    const sub =  nc.subscribe('price');
    for await (const msg of sub){
      console.log(`[${sub.getProcessed()}]: ${strcodec.decode(msg.data)}`);
      }
    })();
  (async ()=>{
    const sub = nc.subscribe('close');
    for await (const msg of sub){
      nc.close();
      console.log('closed!');
      break;
      }
    })();
  
  nc.publish('price', strcodec.encode('4.23'));
  nc.publish('price', strcodec.encode('5.00'));
  //nc.close();
  };
init_nats()


export default null;